extends Control

# Created 2022 by Danil
# The MIT License (only code, code(with shaders) use as you wish, not models, 3d Models not my own)

# read description in shader files /shaders folder
# shaders/edge_cavity.shader - 3 methods use only depth
# shaders/edge_cavity_try2.shader - 2 methods use normal and depth

# Improving quality of edge detection:
# Only way to have better quality of edges - rendeer your scene on 2x resolution of Screen resolution


# WARNING - MODELS USED ONLY FOR DEMONSTRATION, 3D Models NOT MY OWN, they have their author licenses.
# I took them from Sketchfab and use only for demonstration!


# Description of viewports:
# norm_vp used only for normal+depth shader
# color_vp used only when Curve edges enabled and edge_vp render only edges
# edge_vp used by defauly, when selected only depth shader without Curve edges


# P.S. UI logic scuffed, its work its enough


# And REMEMBER you can use "Outline Mesh" for edge-effects to have consistant edge. (google it, can be created in Godot and Blender)


func _ready():
  resize_viewport()
  pass


onready var vp_node = [[get_node("edge_vp"),true],[get_node("norm_vp"),true],
                       [ get_node("color_vp"),false]]
var vp2x = 1

func resize_viewport():
  var local_res = vp_node[0][0].size
  var glob_res = get_viewport().size*vp2x
  var glob_res_o = get_viewport().size*vp2x
  if(int(local_res.x)!=int(glob_res.x))||(int(local_res.y)!=int(glob_res.y)):
    for a in vp_node:
      if(a[1]):
        a[0].size=glob_res
      else:
        a[0].size=glob_res_o

func _process(delta):
  resize_viewport()


func _on_vp2_toggled(button_pressed):
  if(button_pressed):
    vp2x = 2
  else:
    vp2x = 1


func _on_fullscr_pressed():
  OS.window_fullscreen = !OS.window_fullscreen
